// Ex-p5-JSONTextGrid1
// Pour p5.js
// 22 2 2017
// 
// Utilise: libraries/p5.js
// Utilise: libraries/p5.sound.js
// https://p5js.org/reference/#/p5/loadJSON
//
// Ouvre, affiche un fichier .json
// synchro avec la lecture du fichier audio correspondant
// 
// Praat + EasyAlign ou SPPAS -> Fichier .TextGrid
// Fichier .TextGrid -> Fichier .xml  
// XMLisation de TextGrid
// http://cocoon.huma-num.fr/exist/crdo/textgrid.htm
// Fichier .xml -> Fichier .json
// XML to JSON converter
// http://www.utilities-online.info/xmltojson
// 

var Nom = "Amelie";
var NomFichier = "file/" + Nom + ".json";
var NomSon = "file/" + Nom + ".wav";
var Son;
var TextGridJSON;

var NumeroTier = 1;
var Interligne = 14;

var jj, jjj, jjjj;
var yyy = 12;
var iii = 0;
var Fin = 0;

function preload() {
  TextGridJSON = loadJSON(NomFichier);
  Son = loadSound(NomSon);
}

function setup() {
  createCanvas(windowWidth, windowHeight);
  Affiche();
  // Son.loop();
  Son.play();
}

function draw() {
  Cadre("Time: " + int(Son.currentTime() * 10) / 10 + " seconds", 200, 30, 120);
  jjjj = jjj.intervals[iii];
  var ss = jjjj["#text"];
  var Debut = jjjj["-xmin"];
  if (Son.currentTime() > Debut) {
    if (ss != "_") Cadre(iii + "  " + Debut + "  " + ss, 10, 5, 600);
    if (iii < Fin - 1) iii = iii + 1;
  }
}

function Cadre(sss, x, y, xx) {
  fill(255);
  rect(x, y, xx, 20);
  fill(0);
  text(sss, x + 4, y + 15);
}

function Affiche() {
  background(255);
  yyy = 42;

  Ecrire(NomFichier, "");
  Ecrire("", "");
  Ecrire("Filetype: ", TextGridJSON.textgrid["-Filetype"]);
  Ecrire("Objectclass: ", TextGridJSON.textgrid["-Objectclass"]);
  Ecrire("xmin = ", TextGridJSON.textgrid["-xmin"]);
  Ecrire("xmax = ", TextGridJSON.textgrid["-xmax"]);
  var NombreTier = TextGridJSON.textgrid["-size"];
  Ecrire(NombreTier, " tiers" );

  yyy = yyy + Interligne;
  fill(255, 0, 0);
  Ecrire("Taper un n° tier (1 2 3 ...)", "");
  fill(0, 0, 0);
  yyy = yyy + Interligne;

  if (NumeroTier > NombreTier) NumeroTier = NombreTier;
  jjj = TextGridJSON.textgrid.items.item[NumeroTier - 1]; /// 0 1 2 ..
  Ecrire("Tier: ", jjj["-name"])
  Fin = jjj["-intervals"];
  Ecrire(Fin, "intervals")

  for (var i = 0; i < Fin; i++) {
    jjjj = jjj.intervals[i];
    var ss = jjjj["#text"];
    if (ss != "_") Ecrire(i + " ", ss);
  }
  iii = 0;
}

function Ecrire(str1, str2) {
  text(str1 + " " + str2, 10, yyy);
  yyy = yyy + Interligne;
}

function keyPressed() {
  // if (key == '0') NumeroTier = 0; // 
  if (key == '1') NumeroTier = 1; // 
  if (key == '2') NumeroTier = 2; //
  if (key == '3') NumeroTier = 3; //
  if (key == '4') NumeroTier = 4; //
  if (key == '5') NumeroTier = 5; //
  Affiche();
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
  Affiche();
}